<?php


class Emailsequence extends Tools_Plugins_Abstract
{

    const DISPLAY_NAME = 'Email sequence';

    const TAB_MERCHANDISE_ORDER = '5';

    /**
     * System layout
     *
     * @var null
     */
    protected $_layout = null;

    /**
     * Website config
     *
     * @var null
     */
    protected $_websiteConfig = null;

    /**
     * depends on plugins list
     *
     * @var array
     */
    protected $_dependsOn = array(
        'shopping',
        'cart',
        'quote'
    );

    /**
     * additional cart status statuses
     * @return array
     */
    public static function cartStatusEmailStatuses()
    {
      return array('no_cart' => 'No cart');
    }


    /**
     * Init
     *
     * @throws Exceptions_SeotoasterPluginException
     * @throws Zend_Exception
     */
    protected function _init()
    {
        $missedPlugins = array_diff($this->_dependsOn, Tools_Plugins_Tools::getEnabledPlugins(true));

        if (!empty($missedPlugins)) {
            throw new Exceptions_SeotoasterPluginException($this->_translator->translate('Required plugins should be enabled') . ': <b>' . implode(',',
                    $missedPlugins) . '</b>');
        }
        $this->_websiteConfig = Zend_Registry::get('website');

        $this->_layout = new Zend_Layout();
        $this->_layout->setLayoutPath(Zend_Layout::getMvcInstance()->getLayoutPath());

        if ($viewScriptPath = Zend_Layout::getMvcInstance()->getView()->getScriptPaths()) {
            $this->_view->setScriptPath($viewScriptPath);
        }
        $this->_view->addScriptPath(__DIR__ . '/system/views/');
    }

    /**
     * Merchandising tab action
     *
     * @throws Exceptions_SeotoasterPluginException
     */
    public function merchandisingAction()
    {
        if (!Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT)) {
            throw new Exceptions_SeotoasterPluginException('Forbidden');
        }
        $this->_view->websiteConfig = $this->_websiteConfig;

        echo $this->_view->render('merchandisingTab.phtml');
    }


}
