define([
    'backbone',
    './lead-form',
    './lead-grid',
    './lead-product-list',
    './lead-filter-preset-config',
    './lead-detailed-info',
    '../models/lead',
    './lead-main',
    './lead-recently-viewed'
], function(Backbone,
            LeadFormView, LeadGridView, LeadProductListView, LeadFilterPresetConfig, LeadDetailedView, LeadModel, LeadMainView, LeadRecentlyViewedView){
    var LeadsRouter = Backbone.Router.extend({

        routes: {
            ''         : 'index',
            'lead/:id' : 'leadDetails'
        },
        index: function (){

            //init lead grid data
            $('#lead-block').removeClass('hidden');
            this.LeadForm = new LeadFormView();
            this.LeadForm.render();

            this.LeadGrid = new LeadGridView(this.getParams());
            this.LeadGrid.render();

            this.recentlyViewed = new LeadRecentlyViewedView();
            this.recentlyViewed.render();

            this.LeadForm.$el.on('LeadForm:created', _.bind(this.LeadGrid.render, this.LeadGrid));
            this.LeadGrid.$el.on('LeadStatus:changed', _.bind(this.LeadGrid.render, this.LeadGrid));

            this.leadFilterPreset = new LeadFilterPresetConfig();
            this.leadFilterPreset.render();

            this.LeadMainView = new LeadMainView();
            this.LeadMainView.render();

            //this.LeadProductListView = new LeadProductListView();
            //this.LeadProductListView.render();
        },
        leadDetails: function(leadId, params)
        {
            if (!leadId) {
                return false;
            }

            if(!params){
                params = this.getParams();
            }

            this.leadModel =  new LeadModel();
            this.leadModel.set('id', leadId);
            this.leadModel.fetch({data: { isGrid: true, detailedInfo:true},
                'success': function(leadModel){
                    if(_.isUndefined(leadModel.get('lead_email'))) {
                        window.location.href = window.location.pathname;
                    } else {
                        if(!_.isUndefined(this.leadDetailed)) {
                            this.leadDetailed.$el.unbind();
                        }

                        leadModel.customDataParams = params;
                        $('#lead-organizations-recently-viewed-block').addClass('hidden');
                        this.leadDetailed = new LeadDetailedView(leadModel);
                        window.LeadDetailedView = this.leadDetailed;
                        this.leadDetailed.render();
                        $('#lead-table-block').hide();
                        $('.filters').hide();
                        $('#lead-grid-back-link').removeClass('hidden');
                        $('#lead-block').removeClass('hidden');
                        $('#lead-additional-filters').hide();
                        if (window.location.hash !== '') {
                            $('#lead-grid-back').attr('href', $('#website_url').val()+'dashboard/leads/');
                        }
                        $.post($('#website_url').val()+'plugin/leads/run/logLastViewed/', {'id':leadId, 'secureToken':$('#lead-grid-token').val(), 'type':'lead'}, function(){
                        }, 'json');
                    }
                }
            });
        },
       getParams:  function () {
            var result = {},
                tmpData = [];
            location.search
                .substr(1)
                .split("&")
                .forEach(function (item) {
                    tmpData = item.split("=");
                    result[decodeURIComponent(tmpData[0])] = decodeURIComponent(tmpData[1]);
                });
            return result;
        }

    });

    var initialize = function() {
        window.appLeadRouter = new LeadsRouter;
        Backbone.history.start();
    };

    return {
        initialize: initialize
    };
});