define([
    'backbone',
    '../collections/lead-email-sequence',
    './lead-email-sequence-filter-top',
    './lead-email-sequence-filter-bottom',
    './lead-email-sequence-subscribe',
    './lead-email-sequence-log',
    'i18n!../../../nls/dashboard_'+$('#main-dashboard-system-language').val()+'_ln',
    'moment'
], function(Backbone, LeadEmailSequenceCollection, LeadEmailSequenceFilterTopView, LeadEmailSequenceFilterBottomView, LeadEmailSequenceSubscribeView, LeadEmailSequenceLogView,
         i18n, moment
){

    var LeadEmailSequenceView = Backbone.View.extend({
        el: $('#lead-email-sequence-tab-content'),
        events: {
            'click .test-email-sequence-email': 'testEmailSequenceEmail'
        },
        templates: {
        },
        initialize: function(leadId, currentPage){
            this.emailSequenceFilterTopView = new LeadEmailSequenceFilterTopView(leadId);
            this.emailSequenceFilterBottomView = new LeadEmailSequenceFilterBottomView(leadId);
            this.emailSequenceSubscribeView = new LeadEmailSequenceSubscribeView(leadId);
            this.emailSequenceLogView = new LeadEmailSequenceLogView(leadId);
            return this;
        },
        render: function(param){
            this.assign({
                '#lead-email-sequence-list': this.emailSequenceSubscribeView,
                '#lead-email-sequence-log': this.emailSequenceLogView,
                '#lead-email-sequence-filter-block-top': this.emailSequenceFilterTopView,
                '#lead-email-sequence-filter-block-bottom': this.emailSequenceFilterBottomView
            });

            this.emailSequenceFilterTopView.$el.on('EmailSequenceLog:filtered', _.bind(this.emailSequenceLogView.render, this.emailSequenceLogView));
            this.emailSequenceFilterBottomView.$el.on('EmailSequenceLog:filtered', _.bind(this.emailSequenceLogView.render, this.emailSequenceLogView));
        },
        assign: function (selector, view) {
            var selectors;
            if (_.isObject(selector)) {
                selectors = selector;
            }
            else {
                selectors = {};
                selectors[selector] = view;
            }
            if (!selectors) return;
            _.each(selectors, function (view, selector) {
                view.setElement(this.$(selector)).render();
            }, this);
        },
        testEmailSequenceEmail: function(e)
        {
            e.preventDefault();

            var sequenceQueueId = $(e.currentTarget).data('cart-sequence-queue-id');

            $.ajax({
                'url': $('#website_url').val()+'plugin/leads/run/sendCartStatusQueueEmail/',
                'data' : {
                    'secureToken': $('#lead-grid-token').val(),
                    'queueId' : sequenceQueueId
                },
                'type': 'POST',
                'dataType' : 'json'
            }).done(function(response) {
                showMessage(response.responseText, false, 5000);
            }).fail(function(response){
                showMessage(response.responseJSON.responseText, true, 5000);
            });
        }
    });

    return LeadEmailSequenceView;
});