define([
    'backbone',
    'text!../templates/lead-task-detailed-tab.html',
    'i18n!../../../nls/dashboard_'+$('#main-dashboard-system-language').val()+'_ln'
], function(Backbone, leadTaskTmpl, i18n){
    var LeadTaskFormView = Backbone.View.extend({
        el: $('#lead-detailed-view-config-tab-task'),
        events: {
            'submit form': 'submit'
        },
        templates: {

        },
        initialize: function(leadModel, leadTaskDataModel){
            this.leadModel = leadModel;
            this.leadTaskDataModel = leadTaskDataModel;
        },
        render: function(){
            this.$el.empty();
            this.$el.append(_.template(leadTaskTmpl, {'leadModel': this.leadModel, 'leadTaskDataModel': this.leadTaskDataModel, 'i18n' : i18n}));
            this.$el.find('form').attr('action', $('#website_url').val()+'api/leads/leadtask');

            $('#lead-task-date-detailed-view').datepicker({
                dateFormat: 'd-M-yy',
                defaultDate: "+1w",
                changeMonth: true,
                changeYear: true,
                yearRange: "c-5:c+5",
                minDate: 0
            });
            return this;
        },
        submit: function(e){
            e.preventDefault();

            var self = this,
                form = $(e.currentTarget),
                isValid = true,
                startTime = $('#lead-task-start-time').val();

            _.each(form.find('.required'), function(el){
                if (!$(el).val()){
                    isValid = false;
                }
            });

            if (!isValid){
                showMessage(_.isUndefined(i18n['Missing required field'])?'Missing required field':i18n['Missing required field'], true);
                return false;
            }


            form.find('input[name=expired_at]').val(($('#lead-task-date-detailed-view').val()) ? $.datepicker.formatDate('yy-mm-dd', $('#lead-task-date-detailed-view').datepicker("getDate"))+' '+startTime+':00:00': '');

            var formParams = form.serialize()+'&secureToken='+$('#lead-grid-token').val();


            $.ajax({
                url: form.attr('action'),
                type: 'POST',
                data: formParams,
                dataType: 'json'
            }).done(function(response) {
                 showMessage(response.responseText, false, 5000);
                 form.find('textarea').val('');
                 form.find('input[type=text]').val('');
            }).fail(function(response){
                showMessage(response.responseJSON, true, 5000);
            });
            return false;

        }
    });

    return LeadTaskFormView;
});