define([
    'backbone',
    './organization-grid',
    'i18n!../../../nls/dashboard_'+$('#main-dashboard-system-language').val()+'_ln'
], function(Backbone, LeadGridView, i18n
){
    var OrganizationsGridView = Backbone.View.extend({
        el: $('#lead-organization-block'),
        events: {
            'click .switch-lead-organization-creation': 'toggleOrganizationCreation',
            'click #lead-organization-filters-switch': 'toggleLeadOrganizationAdditionalFilters',
            'click #lead-organization-filter-apply': 'applyFilter',
            'click #lead-organization-filter-reset': 'resetFilter',
            'click #lead-organization-filter-reset-top': 'resetFilter',
            'click #go-to-lead-organization-profile, a[data-role=lead-organization-detailed-view]': 'showLeadDetailsScreen',
            'submit #lead-organization-filters-form':'applyFilter'
        },
        templates: {},
        initialize: function(options){

        },
        render: function(){

        },
        toggleOrganizationCreation: function(e){
            e.preventDefault();
            $('#lead-organization-form').slideToggle();
        },
        toggleLeadOrganizationAdditionalFilters: function(){
            $("#lead-organization-additional-filters").toggleClass('hidden');
        },
        applyFilter: function(e) {
            if(typeof e !== 'undefined'){
                e.preventDefault();
            }
            this.LeadGrid = new LeadGridView();
            this.LeadGrid.leadsChecked = [];
            this.LeadGrid.currentPage = 0;
            this.LeadGrid.render();
        },
        resetFilter: function(e){
            e.preventDefault();
            var $filterBlock = $('#lead-organization-additional-filters');
            $filterBlock.find('input:text').val('').end()
                .find('select.filter').val('0').trigger('chosen:updated');
            $('#switch-created-date').prop('checked', true);
            $('#switch-updated-date').prop('checked', false);
            this.applyFilter();
        },
        showLeadDetailsScreen: function(e)
        {
            var organizationId = $(e.currentTarget).data('cid');
            if (!organizationId) {
                return false;
            }
            window.appLeadOrganizationRouter.leadOrganizationDetails(organizationId);
        }
    });

    return OrganizationsGridView;
});